package ch.vanwa.lox_interpreter;

/**
 * Single token.
 *
 * @param type    Type of the token.
 * @param lexeme  Lexeme that produced this token.
 * @param literal Literal value of the token (can be null).
 * @param line    Line number where the token was scannedin the source code.
 */
public record Token(TokenType type, String lexeme, Object literal, int line) {
  @Override
  public String toString() {
    return String.format("%d: %s %s %s", line, type, lexeme, literal);
  }
}
