package ch.vanwa.lox_interpreter;

import static org.junit.jupiter.api.Assertions.assertEquals;

import org.junit.jupiter.api.Test;

/**
 * Unit test for simple App.
 */
public class AppTest {

  /**
   * Simple scanner test.
   */
  @Test
  public void scanOneLine() {
    final var scanner = new Scanner("var language = \"lox\"");
    final var tokens = scanner.scanTokens();

    assertEquals(5, tokens.size());

    assertEquals(new Token(TokenType.VAR, "var", null, 1), tokens.get(0));
    assertEquals(new Token(TokenType.IDENTIFIER, "language", null, 1), tokens.get(1));
    assertEquals(new Token(TokenType.EQUAL, "=", null, 1), tokens.get(2));
    assertEquals(new Token(TokenType.STRING, "\"lox\"", "lox", 1), tokens.get(3));
    assertEquals(new Token(TokenType.EOF, "", null, 1), tokens.get(4));
  }
}
